<template>
  <div id="jzot-form">

    <button v-if="$store.state.user?.is_superuser" class="btn btn-primary" type="button" @click=on_browse>Przeglądaj</button>

<!-- @TODO move this select to component mayby -->
    <select
      name="air_ship_type"
      id="air_ship_type"
      v-model="jzot_object.airship_type"
    >
      <option value="null" disabled>air_ship_type</option>
      <option v-for="val in airship_type_list" :key="val.id" :value="val.id">{{val.name}}</option>
    </select>

    <select
      name="specialization"
      id="specialization"
      v-model="jzot_object.specialization"
      @change="specChanged"
    >
      <option value="null" disabled>specialization</option>
      <option v-for="spec in specialization_list" :key="spec.id" :value="spec.id">{{spec.name}}</option>
    </select>

    <input type="text" v-model="jzot_object.system" placeholder="system" />
    <input type="text" v-model="jzot_object.aggregate" placeholder="aggregate" />
    <input type="text" v-model="jzot_object.point_number" placeholder="point_number" />


    <textarea rows="4" cols="50" v-model="jzot_object.point_text" placeholder="point_text">
    </textarea>

    <select
      name="technologic_card"
      id="technologic_card"
      v-model="jzot_object.technologic_card"
    >
      <option value="null" disabled>technologic_card</option>
      <option v-for="val in technologic_card_list" :key="val.id" :value="val.id">{{val.number}}</option>
    </select>


    <select
      name="handlings_level"
      id="handlings_level"
      v-model="jzot_object.handlings_level"
    >
      <option value="null" disabled>handlings_level</option>
      <option v-for="val in handlings_level_list" :key="val.id" :value="val.id">{{val.level}}</option>
    </select>

    <button @click="CreateJzot">{{submit_text}}</button>

    <span id="error_message">{{error_message}}</span>
  </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { getSpecializations, getHandlingsLevels, getAirshipTypes, getTechnologicCards, createDataBaseObject, getJzotById, putDataBaseObject } from "../../utils/apiUtils";

const jzot_url = "http://127.0.0.1:8000/handlings/jzot/";

export default {
  name: "JzotCreate",
  props: {
    initial_object : Object,
    id : String,
    after_post_callback : Function,
    on_browse : Function
  },
  data: function() {
    return {
      jzot_object:{
        airship_type: null,
        specialization: null,
        system: "",
        aggregate: "",
        point_number: "",
        point_text: "",
        technologic_card: null,
        technologic_card_url: "",
        handlings_level: null,
      },

      airship_type_list: [],
      specialization_list: [],
      technologic_card_list: [],
      handlings_level_list: [],

      submit_text: "Create",
      error_message: ""
    };
  },
  methods: {
    JzotObjectClear() {
        this.jzot_object = {
            airship_type: null,
            specialization: null,
            system: "",
            aggregate: "",
            point_number: "",
            point_text: "",
            technologic_card: null,
            technologic_card_url: "",
            handlings_level: null,
      };
    },
    CreateJzot() {
        (async () => {
            try {
              if (this.submit_text == "Create") {
                await createDataBaseObject(jzot_url, this.jzot_object, "jzot");
                this.JzotObjectClear();
              } else if (this.submit_text == "Edit") {
                await putDataBaseObject(jzot_url + this.initial_object.id + "/", this.jzot_object, "jzot");
              }
              this.after_post_callback?.();
            } catch (error) {
                this.error_message = error;
            }
        })();
    },
    specChanged() {},
  },

  mounted: function() {
    if (this.initial_object) {
      console.log("initial obj:", this.initial_object);
      this.jzot_object = this.initial_object;
      console.log("jzot obj:", this.jzot_object);
      this.submit_text = "Edit";
    }
    else if (this.id) {
      (async () => {
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        this.jzot_object = await getJzotById(this.id);
      })();
      this.submit_text = "Edit";
    }

    (async () => {
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        this.airship_type_list = await getAirshipTypes();
        this.specialization_list = await getSpecializations();
        this.technologic_card_list = await getTechnologicCards();
        this.handlings_level_list = await getHandlingsLevels();
    })();
  }
};
</script>

<style scoped>
/* @TODO do something with this styles!!! - make it global or something */
#jzot-form {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-left: 40%;
  margin-right: 40%;
}
input {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}

textarea {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}

select {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}
#error_message {
  color: red;
}
</style>>